import { AnyCodec } from '../definitions';
export declare enum TransformTarget {
    Encoded = "encoded",
    Decoded = "decoded"
}
export declare type BaseParserParams = {
    target: TransformTarget;
    parsers: Parser<string, AnyCodec>[];
    allowAdditional: boolean;
};
export declare type GenerationOptions = Partial<BaseParserParams>;
export declare type RecursiveCodecCache = Map<string, any>;
export declare type ParserContext = BaseParserParams & {
    cache: RecursiveCodecCache;
};
export declare type ParserFunction<C extends AnyCodec> = (codec: C, context: ParserContext) => any;
export declare type Parser<T extends string, C extends AnyCodec> = {
    tag: T;
    parse: ParserFunction<C>;
};
